/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of DDCCI.xs. Do not edit this file, edit DDCCI.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "DDCCI.xs"
#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

/* I2C & DDC/CI functions */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <string.h>
#include <linux/i2c.h>
#include <linux/i2c-dev.h>
#include <fcntl.h>
#include <sys/ioctl.h>

// general constants
#define MSG_MAX_LEN	127		// max i2c message length
#define REPLY_DELAY	50000	// uS to wait after write to get the response

// ddc/ci constants
#define DDCCI_COMMAND_READ	0x01	// read ctrl value
#define DDCCI_REPLY_READ	0x02	// read ctrl value reply */
#define DDCCI_COMMAND_WRITE	0x03	// write ctrl value */
//#define DDCCI_COMMAND_SAVE	0x0c	// save current settings */
#define DDCCI_COMMAND_CAPS	0xf3	// get monitor caps */
#define DDCCI_REPLY_CAPS	0xe3	// get monitor caps reply */

#define DDCCI_ADDR	0x37	// DDC/CI default addr
#define EDID_ADDR	0x50	// EDID default addr

// magic numbers
#define MAGIC_1		0x51	// first byte to send, host address
#define MAGIC_2		0x80	// second byte to send, ORed with length
#define MAGIC_XOR	0x50	// initial XOR for received frame

/*
 * VCPs lookup table functions
*/
const char *_vcp_name(unsigned char addr) {
	switch (addr) {
		case 0x00: return "Code Page";	
		case 0x01: return "Degauss";	
		case 0x02: return "Secondary Degauss";	
		case 0x04: return "Reset Factory Defaults";
		case 0x05: return "Reset Brightness and Contrast";	
		case 0x06: return "Reset Factory Geometry";
		case 0x08: return "Reset Factory Default Color";	
		case 0x0a: return "Reset Factory Default Position";	
		case 0x0c: return "Reset Factory Default Size";		
		case 0x0e: return "Image Lock Coarse";	
		case 0x10: return "Brightness";
		case 0x12: return "Contrast";
		case 0x14: return "Select Color Preset";	
		case 0x16: return "Red Video Gain";
		case 0x18: return "Green Video Gain";
		case 0x1a: return "Blue Video Gain";
		case 0x1c: return "Focus";	
		case 0x1e: return "Auto Size Center";	
		case 0x20: return "Horizontal Position";
		case 0x22: return "Horizontal Size";
		case 0x24: return "Horizontal Pincushion";
		case 0x26: return "Horizontal Pincushion Balance";
		case 0x28: return "Horizontal Misconvergence";
		case 0x2a: return "Horizontal Linearity";
		case 0x2c: return "Horizontal Linearity Balance";
		case 0x30: return "Vertical Position";
		case 0x32: return "Vertical Size";
		case 0x34: return "Vertical Pincushion";
		case 0x36: return "Vertical Pincushion Balance";
		case 0x38: return "Vertical Misconvergence";
		case 0x3a: return "Vertical Linearity";
		case 0x3c: return "Vertical Linearity Balance";
		case 0x3e: return "Image Lock Fine";	
		case 0x40: return "Parallelogram Distortion";
		case 0x42: return "Trapezoidal Distortion";
		case 0x44: return "Tilt (Rotation)";
		case 0x46: return "Top Corner Distortion Control";
		case 0x48: return "Top Corner Distortion Balance";
		case 0x4a: return "Bottom Corner Distortion Control";
		case 0x4c: return "Bottom Corner Distortion Balance";
		case 0x50: return "Hue";	
		case 0x52: return "Saturation";	
		case 0x54: return "Color Curve Adjust";	
		case 0x56: return "Horizontal Moire";
		case 0x58: return "Vertical Moire";
		case 0x5a: return "Auto Size Center Enable/Disable";	
		case 0x5c: return "Landing Adjust";	
		case 0x5e: return "Input Level Select";	
		case 0x60: return "Input Source Select";
		case 0x62: return "Audio Speaker Volume Adjust";	
		case 0x64: return "Audio Microphone Volume Adjust";	
		case 0x66: return "On Screen Display Enable/Disable";	
		case 0x68: return "Language Select";	
		case 0x6c: return "Red Video Black Level";
		case 0x6e: return "Green Video Black Level";
		case 0x70: return "Blue Video Black Level";
		case 0xa2: return "Auto Size Center";	
		case 0xa4: return "Polarity Horizontal Synchronization";	
		case 0xa6: return "Polarity Vertical Synchronization";	
		case 0xa8: return "Synchronization Type";	
		case 0xaa: return "Screen Orientation";	
		case 0xac: return "Horizontal Frequency";	
		case 0xae: return "Vertical Frequency";	
		case 0xb0: return "Restore Settings";
		case 0xca: return "On Screen Display";	
		case 0xcc: return "On Screen Display Language";	
		case 0xd4: return "Stereo Mode";	
		case 0xd6: return "DPMS control";
		case 0xdc: return "MagicBright";
		case 0xdf: return "VCP Version";	
		case 0xe0: return "Color preset";
		case 0xe1: return "Power control";
		case 0xed: return "Red Video Black Level";
		case 0xee: return "Green Video Black Level";
		case 0xef: return "Blue Video Black Level";
		case 0xf5: return "VCP Enable";
		default: return "???";
	}
}
int _vcp_addr(const char *name) {
	int i;
	const char *n;

	if (!name || (*name == '\0'))
		return -1;

	for (i = 0; i <= 0xff; i++) {
		if (strcmp((n = _vcp_name(i)), "???") == 0)
			continue;
		if (strcasecmp(name, n) == 0)
			return i;
	}

	return -1;
}

/*
 * write len bytes (stored in buf) to i2c address addr
 * return 0 on success, < 0 on failure
*/
int _i2c_write(int fd, unsigned char addr, unsigned char *buf, unsigned char len) {
	struct i2c_rdwr_ioctl_data msg_rdwr;
	struct i2c_msg i2cmsg;

	msg_rdwr.msgs = &i2cmsg;
	msg_rdwr.nmsgs = 1;

	i2cmsg.addr = addr;
	i2cmsg.flags = 0;
	i2cmsg.len = len;
	i2cmsg.buf = buf;

	return ioctl(fd, I2C_RDWR, &msg_rdwr);
}

/*
 * read at most len bytes from i2c address addr, to buf
 * return 0/1 on success, < 0 on failure
*/
int _i2c_read(int fd, unsigned char addr, unsigned char *buf, unsigned char len) {
	struct i2c_rdwr_ioctl_data msg_rdwr;
	struct i2c_msg i2cmsg;

	msg_rdwr.msgs = &i2cmsg;
	msg_rdwr.nmsgs = 1;

	i2cmsg.addr = addr;
	i2cmsg.flags = I2C_M_RD;
	i2cmsg.len = len;
	i2cmsg.buf = buf;

	return ioctl(fd, I2C_RDWR, &msg_rdwr);
}

/*
 * write len bytes from *buf to ddc/ci at address addr
 * return 0 on success, < 0 on failure
*/
int _ddcci_write(int fd, unsigned char addr, unsigned char *buf, unsigned char len) {
	int i = 0;
	unsigned char tmp[MSG_MAX_LEN + 3];
	unsigned char xor = (unsigned char)(addr << 1);

	// first magic
	xor ^= (tmp[i++] = MAGIC_1);
	
	// 2nd magic + message size
	xor ^= (tmp[i++] = MAGIC_2 | len);
	
	// msg
	while (len--)
		xor ^= (tmp[i++] = *buf++);
		
	// msg checksum
	tmp[i++] = xor;

	// write to i2c
	return _i2c_write(fd, addr, tmp, i);
}

/*
 * read ddc/ci formatted frame from ddc/ci at address addr to buf
 * return msg len on success, < 0 on failure
*/
int _ddcci_read(int fd, unsigned char addr, unsigned char *buf, unsigned char len) {
	int i, r;
	unsigned char tmp[MSG_MAX_LEN + 3];
	unsigned char xor = MAGIC_XOR;

	memset(buf, 0, len);

	// read raw data
	if (
		(_i2c_read(fd, addr, tmp, len + 3) <= 0) || 
		(tmp[0] == 0x51) || 
		(tmp[0] == 0xff)
	)
		return -1;
	
	// validate answer
	if (tmp[0] != addr << 1)
		return -1;
	if ((tmp[1] & MAGIC_2) == 0)
		return -1;
	r = tmp[1] & ~MAGIC_2;
	for (i = 0; i <= r + 2; i++)
		xor ^= tmp[i];
	if (xor != 0)
		return -1;
	if (r > len)
		return -1;

	// copy payload data
	memcpy(buf, tmp + 2, r);
	
	return r;
}

/* 
 * write value to register of ddc/ci at default address
 * return 0 on success, < 0 on failure
*/
int _ddcci_write_vcp(int fd, unsigned char vcp, unsigned short value) {
	unsigned char tmp[4];

	tmp[0] = DDCCI_COMMAND_WRITE;
	tmp[1] = vcp;
	tmp[2] = (value >> 8);
	tmp[3] = (value & 255);

	return _ddcci_write(fd, DDCCI_ADDR, tmp, sizeof(tmp));
}

/*
 * read value from register of ddc/ci from default address
 * return 0 on success, < 0 on failure
*/
int _ddcci_read_vcp(int fd, unsigned char vcp, unsigned short *value, unsigned short *max, unsigned char *type) {
	unsigned char buf[8];
	int r;
	uint16_t vc, vm;

	buf[0] = DDCCI_COMMAND_READ;
	buf[1] = vcp;

	if (_ddcci_write(fd, DDCCI_ADDR, buf, 2) < 0)
		return -1;

   	usleep(REPLY_DELAY);
    	
	if ((r = _ddcci_read(fd, DDCCI_ADDR, buf, sizeof(buf))) < 0)
		return r;

	// data structure:	
	//  0              1                           2     3                                4             5             6              7
	// [reply opcode]-[result code: 0=ok, 1=fail]-[reg]-[type: 0=permanent, 1=temporary]-[max value H]-[max value L]-[curr value H]-[currvalue L]
	if (
		(r != sizeof(buf)) || 
		(buf[0] != DDCCI_REPLY_READ) ||
		buf[1] ||
		(buf[2] != vcp) 
	) 
		return -1;

	vc = (buf[6] << 8) + buf[7];
	vm = (buf[4] << 8) + buf[5];

	if (value) *value = vc;
	if (max) *max = vm;
	if (type) *type = buf[3];
	return 0;
}

/*
 * read capabilities raw data of ddc/ci from default address starting at offset to buf
 * return msg len on success, < 0 on failure
*/
int _ddcci_caps(int fd, char **buf) {
	unsigned char tmp[32 + 3];	// max chunk size + hdr (not sure about hdr, conservative programming...)
	void *p;
	int i, r, len = 0;
	unsigned short offset = 0;

	*buf = NULL;

	do {
		tmp[0] = DDCCI_COMMAND_CAPS;
		tmp[1] = offset >> 8;
		tmp[2] = offset & 0xff;

		if (_ddcci_write(fd, DDCCI_ADDR, tmp, sizeof(tmp)) < 0) 
			goto err;
		
		usleep(REPLY_DELAY);

		if ((r = _ddcci_read(fd, DDCCI_ADDR, tmp, sizeof(tmp))) < 0)
			goto err;

		if (
			(r < 3) ||
			(tmp[0] != DDCCI_REPLY_CAPS) ||
			((tmp[1] << 8) + tmp[2] != offset)
		)
			goto err;
	
		if (!(p = realloc(*buf, len + (r - 3) * 6 + 1)))
			goto err;
		*buf = p;

		for (i = 3; i < r; i++)
			len += sprintf(*buf+len, ((tmp[i] >= 0x20) && (tmp[i] < 127)) ? "%c" : " 0x%02x ", tmp[i]);
			
		offset += r - 3;
		usleep(REPLY_DELAY);
	} while (r > 3);

	return len;

err:
	free(*buf);
	*buf = NULL;
	return -1;
}

/*
 * read the first (mandatory) block of EDID (128 bytes)
 * return len on success, < 0 on failure
*/
int _ddcci_edid(int fd, unsigned char **buf) {
	int r;
	unsigned char tmp = 0;

	if (!(*buf = malloc(128)))
		return -1;

	memset(*buf, 0, 128);

	if ((r = _i2c_write(fd, EDID_ADDR, &tmp, 1)) < 0)
		goto err;
	 
	if ((r = _i2c_read(fd, EDID_ADDR, *buf, 128)) < 0)
		goto err;

	return 128;

err:
	free(*buf);
	*buf = NULL;
	return -1;
}

#line 387 "DDCCI.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 531 "DDCCI.c"

XS_EUPXS(XS_DDCCI__get_vcp_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_DDCCI__get_vcp_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "addr");
    {
	unsigned char	addr = (unsigned char)SvUV(ST(0))
;
	SV *	RETVAL;
#line 385 "DDCCI.xs"
		RETVAL = newSVpv(_vcp_name(addr), 0);
#line 545 "DDCCI.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_DDCCI__get_vcp_addr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_DDCCI__get_vcp_addr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	const char *	name = (const char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
#line 393 "DDCCI.xs"
		RETVAL = newSViv(_vcp_addr(name));
#line 565 "DDCCI.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_DDCCI__open_dev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_DDCCI__open_dev)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fn");
    {
	const char *	fn = (const char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 401 "DDCCI.xs"
        RETVAL = open(fn, O_RDWR);
#line 586 "DDCCI.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_DDCCI__close_dev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_DDCCI__close_dev)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;
#line 409 "DDCCI.xs"
		RETVAL = close(fd);
#line 607 "DDCCI.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_DDCCI__read_vcp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_DDCCI__read_vcp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, vcp");
    {
	int	fd = (int)SvIV(ST(0))
;
	unsigned char	vcp = (unsigned char)SvUV(ST(1))
;
	SV *	RETVAL;
#line 418 "DDCCI.xs"
		unsigned short value;
		if (_ddcci_read_vcp(fd, vcp, &value, NULL, NULL) < 0)
			RETVAL = newSV(0);
		else 
			RETVAL = newSVuv(value);
#line 633 "DDCCI.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_DDCCI__write_vcp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_DDCCI__write_vcp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, vcp, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	unsigned char	vcp = (unsigned char)SvUV(ST(1))
;
	unsigned short	value = (unsigned short)SvUV(ST(2))
;
	SV *	RETVAL;
#line 432 "DDCCI.xs"
		if (_ddcci_write_vcp(fd, vcp, value) < 0)
			RETVAL = newSV(0);
		else 
			RETVAL = newSVuv(value);
#line 660 "DDCCI.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_DDCCI__read_caps); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_DDCCI__read_caps)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	SV *	RETVAL;
#line 443 "DDCCI.xs"
		char *caps = NULL;
		int len;
		if ((len = _ddcci_caps(fd, &caps)) < 0)
			RETVAL = newSV(0);
		else
			RETVAL = newSVpvn(caps, len);
		free(caps);
#line 686 "DDCCI.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_DDCCI__read_edid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_DDCCI__read_edid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	SV *	RETVAL;
#line 457 "DDCCI.xs"
		unsigned char *edid = NULL;
		int len;
		if ((len = _ddcci_edid(fd, &edid)) < 0)
			RETVAL = newSV(0);
		else
			RETVAL = newSVpvn((const char *)edid, len);
		free(edid);
#line 712 "DDCCI.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_DDCCI); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_DDCCI)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("DDCCI::_get_vcp_name", XS_DDCCI__get_vcp_name);
        newXS_deffile("DDCCI::_get_vcp_addr", XS_DDCCI__get_vcp_addr);
        newXS_deffile("DDCCI::_open_dev", XS_DDCCI__open_dev);
        newXS_deffile("DDCCI::_close_dev", XS_DDCCI__close_dev);
        newXS_deffile("DDCCI::_read_vcp", XS_DDCCI__read_vcp);
        newXS_deffile("DDCCI::_write_vcp", XS_DDCCI__write_vcp);
        newXS_deffile("DDCCI::_read_caps", XS_DDCCI__read_caps);
        newXS_deffile("DDCCI::_read_edid", XS_DDCCI__read_edid);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
